<?php
/*
Plugin Name: gWpExcerpt
Plugin URI: http://blog.ghiboz.com/gwpexcerpt
Description: With this plugin you're allowed to change the excerpt length that is by default 50 words
Author: ghiboz
Version: 1.0.1

Author URI: http://www.ghiboz.com

Copyright 2009 by Paolo ghiboz Ghibaudo

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// Stop direct call
if( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) { die( 'You are not allowed to call this page directly.' ); }

if( !class_exists( 'gWpExcerpt' ) ) {
    class gWpExcerpt {
        
        // WordPress hooks
        function gWpExcerpt( ) {
            
            // scripts
            wp_enqueue_script( "gWpExcerpt", path_join( WP_PLUGIN_URL, basename( dirname( __FILE__ ) )."/gWpExcerpt.js" ), array( 'jquery' ) );

            // excerpt
            add_filter( 'excerpt_length', array( &$this, 'NewExcerptLength' ) );
            
    		// admin menu
    		add_action( 'admin_menu', array(&$this, 'gWpExcerpt_AdminMenu') );
        }
        
    	function gWpExcerpt_AdminMenu( ) {
    		if( function_exists( 'add_options_page' ) )
    			add_options_page(__( 'gWpExcerpt Configuration' ), __( 'gWpExcerpt' ), 99, __FILE__, array( &$this, 'gWpExcerpt_Config' ) );
    	}

    	function gWpExcerpt_Config() {
    		$optSize = get_option( 'gWpExcerpt_size' );
    		if( intval( $optSize ) == 0) {
    		    $optSize = 50;
    		}
    		
    		if ( isset($_POST['Submit']) ) {
    			//check_admin_referer('syntaxhighlighterplus-update-options');
    			$optSize = $_POST[ 'size' ];
    			update_option('gWpExcerpt_size', $optSize);
    			echo '<div id="message" class="updated fade"><p><strong>' . __( 'Settings saved.' ) . '</strong></p></div>';
    		}
    		?>
    		<div class="wrap">
	            <div id="icon-options-general" class="icon32"><br /></div>        
    			<h2><?php _e('gWpExcerpt Configuration'); ?>.</h2>
    			<form action="" method="post" id="gWpExcerpt" accept-charset="utf-8">
    				<h3>set Excerpt length</h3>
    				<input type='text' id='size' name='size' size='20' value='<?php echo strval( $optSize ); ?>' onKeyPress='return NumbersOnly( this, event )'/>
    				<p class="submit"><input type="submit" name="Submit" class="button-primary" value="<?php _e('Save Changes') ?>"/></p>
    			</form>
    			<p><a href='http://www.ghiboz.com' target='_blank'>powered by <img src='http://www.ghiboz.com/logo.png'/></a></p>
    		</div>
    		<?php
    	}
    	
        function NewExcerptLength( $length ) {
    		$optSize = get_option( 'gWpExcerpt_size' );
    		if( intval( $optSize ) == 0) {
    		    $optSize = 50;
    		}
        	return intval( $optSize );
        }
    }
}
// Initiate the plugin class
$gWpExcerpt = new gWpExcerpt( );
?>